
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform  float progress;
uniform  float ratio;


vec4 getToColor(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}
vec4 getFromColor(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

void main() {
    if(progress>0.98){
        gl_FragColor=texture2D(inputImageTexture2, textureCoordinate);
        return;
    }
    if(progress<0.02){
        gl_FragColor=texture2D(inputImageTexture, textureCoordinate);
        return;
    }

    vec2 texCoord = textureCoordinate.xy/ vec2(1.0);
    float ratio2=16.0/9.0;
    if(ratio2>ratio){
        texCoord.x=0.5+(texCoord.x-0.5)*ratio/ratio2;
    }else{
        texCoord.y=0.5+(texCoord.y-0.5)/ratio*ratio2;
    }


    //    gl_FragColor=progress<0.5?getToColor(texCoord):getFromColor(texCoord);
    //    gl_FragColor+=cadd;

    //    gl_FragColor=getFromColor(texCoord)*0.5+getToColor(texCoord)*0.5;

    vec4 cadd=texture2D(inputImageTexture3, texCoord);
    gl_FragColor=mix(
    texture2D(inputImageTexture, textureCoordinate),
    texture2D(inputImageTexture2, textureCoordinate), cadd.r);//step(0.5,cadd.r)
}
